Foxit PDF SDK

Public Member Functions | List of all members
foxit.pdf.RevocationCallback Class Reference

Inherits SystemIDisposable.

## Public Member Functions
virtual StringArray | GetCertChainFromSignature (byte[] signature_content)
| A callback function used to get the cert chain from the signature content. More...
virtual TimeRange | GetCertValidTimeRange (byte[] cert)
| A callback function used to get the time range that represents validity period of a certificate. More...
virtual byte [] | GetCRLSignature (byte[] crl_data)
| A callback function used to get the signature content from a CRL response. More...
virtual DateTime | GetDTSTime (byte[] signature_content)
| A callback function used to get the DTS (document time stamp signature) time from signature content. More...
virtual CertIssuerPair | GetOCSPCertAndIssuer (byte[] ocsp_data, byte[][] trust_cert_chain)
| A callback function used to get the cert-issuer pair of OCSP response. More...
virtual DateTime | GetOCSPProducedAtTime (byte[] ocsp_data)
| A callback function used to get the produce time of the OCSP response. More...
virtual byte [] | GetOCSPSignature (byte[] ocsp_data)
| A callback function used to get the signature content from a OCSP response. More...
virtual Response | GetResponseOnLineForSingleCert (CertIssuerPair cert_issuer_pair)
| A callback function used to get response online for a certificate. More...
virtual RevocationArrayInfo | GetRevocationInfoFromSignatureData (byte[] signature_content)
| A callback function used to get the revocation information (in array type) from a signature. More...
virtual byte [] | GetTSTSignature (byte[] signature_content)
| A callback function used to get the time stamp token content from a signature content. More...
virtual DateTime | GetTSTTime (byte[] signature_content)
| A callback function used to get the time stamp token time from signature content. More...
virtual bool | IsCA (byte[] cert)
| A callback function used to judge whether a certificate is a CA certificate. More...
virtual bool | IsIssuerMatchCert (CertIssuerPair cert_issuer_pair)
| A callback function used to check if an issuer matches a certificate. More...
virtual bool | IsOCSPNeedCheck (byte[] ocsp_data)
| A callback function used to get flag which decides if need to check OCSP response. More...
virtual void | Release ()
| A callback function used to release current callback object itself. More...
virtual CertVerifyResult | VerifyCRL (CertIssuerPair cert_issuer_pair, byte[] crl_data)
| A callback function used to verify whether the CRL response matches the certificate and get the verify result for the certificate. More...
virtual CertVerifyResult | VerifyOCSP (CertIssuerPair cert_issuer_pair, byte[] ocsp_data)
| A callback function used to verify whether the OCSP response matches the certificate and get the verify result for the certificate. More...

## Detailed Description

This class represent a revocation callback object which is used for class LTVVerifier . All the pure virtual functions in this class are used as callback functions and should be implemented by user.

See also
  LTVVerifier

## Member Function Documentation

## ◆ GetCertChainFromSignature()

StringArray foxit.pdf.RevocationCallback.GetCertChainFromSignature | ( | byte [] | signature_content | ) |
| inline virtual

A callback function used to get the cert chain from the signature content.

Parameters

  [in] | signature_content | Signature content.

Returns
  An array that represents the cert chain.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetCertValidTimeRange()

TimeRange foxit.pdf.RevocationCallback.GetCertValidTimeRange | ( | byte [] | cert | ) |
| inline virtual

A callback function used to get the time range that represents validity period of a certificate.

Parameters

  [in] | cert | Certificate content.

Returns
  Time range that represents validity period of the certificate.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetCRLSignature()

byte[] foxit.pdf.RevocationCallback.GetCRLSignature | ( | byte [] | crl_data | ) |
| inline virtual

A callback function used to get the signature content from a CRL response.

Parameters

  [in] | crl_data | CRL response content.

Returns
  Signature content .

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetDTSTime()

DateTime foxit.pdf.RevocationCallback.GetDTSTime | ( | byte [] | signature_content | ) |
| inline virtual

A callback function used to get the DTS (document time stamp signature) time from signature content.

Parameters

  [in] | signature_content | Signature content.

Returns
  DTS time. utc_hour_offset and utc_minite_offset of this time would be ignored.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetOCSPCertAndIssuer()

CertIssuerPair foxit.pdf.RevocationCallback.GetOCSPCertAndIssuer | ( | byte [] | ocsp_data,
|  | byte | trust_cert_chain[][]
| ) |  |
| inline virtual

A callback function used to get the cert-issuer pair of OCSP response.

Parameters

  [in] | ocsp_data | OCSP response data.
  [in] | trust_cert_chain | The trust cert chain used to find the issuer of the OCSP cert.

Returns
  A cert-issuer pair that obtained from OCSP.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetOCSPProducedAtTime()

DateTime foxit.pdf.RevocationCallback.GetOCSPProducedAtTime | ( | byte [] | ocsp_data | ) |
| inline virtual

A callback function used to get the produce time of the OCSP response.

Parameters

  [in] | ocsp_data | OCSP response content.

Returns
  Produce time of the OCSP response. utc_hour_offset and utc_minite_offset of this time would be ignored.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetOCSPSignature()

byte[] foxit.pdf.RevocationCallback.GetOCSPSignature | ( | byte [] | ocsp_data | ) |
| inline virtual

A callback function used to get the signature content from a OCSP response.

Parameters

  [in] | ocsp_data | OCSP response content.

Returns
  Signature content.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetResponseOnLineForSingleCert()

Response foxit.pdf.RevocationCallback.GetResponseOnLineForSingleCert | ( | CertIssuerPair | cert_issuer_pair | ) |
| inline virtual

A callback function used to get response online for a certificate.

Parameters

  [in] | cert_issuer_pair | A cert-issuer pair which represents a certificate and an issuer for the certificate.

Returns
  Response for the certificate.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetRevocationInfoFromSignatureData()

RevocationArrayInfo foxit.pdf.RevocationCallback.GetRevocationInfoFromSignatureData | ( | byte [] | signature_content | ) |
| inline virtual

A callback function used to get the revocation information (in array type) from a signature.

Parameters

  [in] | signature_content | Signature content.

Returns
  Information in array type of revocation information.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetTSTSignature()

byte[] foxit.pdf.RevocationCallback.GetTSTSignature | ( | byte [] | signature_content | ) |
| inline virtual

A callback function used to get the time stamp token content from a signature content.

Parameters

  [in] | signature_content | Signature content.

Returns
  Time stamp token content.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ GetTSTTime()

DateTime foxit.pdf.RevocationCallback.GetTSTTime | ( | byte [] | signature_content | ) |
| inline virtual

A callback function used to get the time stamp token time from signature content.

Parameters

  [in] | signature_content | Signature content.

Returns
  Time of time stamp token of a signature. utc_hour_offset and utc_minite_offset of this time would be ignored.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ IsCA()

bool foxit.pdf.RevocationCallback.IsCA | ( | byte [] | cert | ) |
| inline virtual

A callback function used to judge whether a certificate is a CA certificate.

Parameters

  [in] | cert | Certificate content.

Returns
  true means the certificate is a CA certificate, while false means not.

## ◆ IsIssuerMatchCert()

bool foxit.pdf.RevocationCallback.IsIssuerMatchCert | ( | CertIssuerPair | cert_issuer_pair | ) |
| inline virtual

A callback function used to check if an issuer matches a certificate.

Parameters

  [in] | cert_issuer_pair | A cert-issuer pair. Issuer in this pair is to be checked if it matches the ceritificate in this pair.

Returns
  true means issuer matches the certificate, while false means not.

## ◆ IsOCSPNeedCheck()

bool foxit.pdf.RevocationCallback.IsOCSPNeedCheck | ( | byte [] | ocsp_data | ) |
| inline virtual

A callback function used to get flag which decides if need to check OCSP response.

Parameters

  [in] | ocsp_data | OCSP response content.

Returns
  true means need to check OCSP response, while false means no need.

## ◆ Release()

void foxit.pdf.RevocationCallback.Release | ( |  | ) |
| inline virtual

A callback function used to release current callback object itself.

Returns
  None.

## ◆ VerifyCRL()

CertVerifyResult foxit.pdf.RevocationCallback.VerifyCRL | ( | CertIssuerPair | cert_issuer_pair,
|  | byte [] | crl_data
| ) |  |
| inline virtual

A callback function used to verify whether the CRL response matches the certificate and get the verify result for the certificate.

Parameters

  [in] | cert_issuer_pair | A cert-issuer pair which represents a certificate and an issuer for the certificate.
  [in] | crl_data | CRL content.

Returns
  Certificate verify result that obtained from CRL.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .

## ◆ VerifyOCSP()

CertVerifyResult foxit.pdf.RevocationCallback.VerifyOCSP | ( | CertIssuerPair | cert_issuer_pair,
|  | byte [] | ocsp_data
| ) |  |
| inline virtual

A callback function used to verify whether the OCSP response matches the certificate and get the verify result for the certificate.

Parameters

  [in] | cert_issuer_pair | A cert-issuer pair which represents a certificate and an issuer for the certificate.
  [in] | ocsp_data | OCSP content.

Returns
  Certificate verify result that obtained from CRL.

Note
  User can throw exception for errors. Please refer to class foxit.PDFException and values starting from foxit.common.ErrorCode.e_ErrFile .